<?php
namespace Pinpoint\Conesso\Console\Command\Contacts;

use Pinpoint\Conesso\Model\Api\Management\Process\ProcessFactory;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class Migrate Customer Command
 */
class MigrateContactsCommand extends Command
{
    /**
     * @param ProcessFactory $processFactory
     */
    public function __construct(
        private readonly ProcessFactory $processFactory
    )
    {
        parent::__construct();
    }

    /**
     * @inheritDoc
     */
    protected function configure(): void
    {
        $this->setName('conesso:migrate:contacts');
        $this->setDescription('Truncate all existing rows of conesso customer table and populate table with new entry.');
        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int
     */
    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $result = $this->processFactory->getProcess('customer')->migrateData();
        $output->writeln('<info>Success Message.</info>');
        return 0;
    }
}
