<?php
namespace Pinpoint\Conesso\Console\Command\Contacts;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;
use Pinpoint\Conesso\Model\Api\Management\Process\ProcessFactory;

/**
 * Class  Sync Contact Command
 */
class SyncContactsCommand extends Command
{
    const BATCH_SIZE = 'batch_size';
    const STORE_ID = 'store_id';

    /**
     * @param ProcessFactory $processFactory
     */
    public function __construct(
        private readonly ProcessFactory $processFactory
    )
    {
        parent::__construct();
    }

    /**
     * @inheritDoc
     */
    protected function configure()
    {
        $this->setName('conesso:sync:contacts');
        $this->setDescription('Forced running of all pending events in the conesso contact table.');

        $this->addOption(
            self::BATCH_SIZE,
            null,
            InputOption::VALUE_OPTIONAL,
            'Batch Size'
        );

        $this->addOption(
            self::STORE_ID,
            null,
            InputOption::VALUE_OPTIONAL,
            'Store Id'
        );

        parent::configure();
    }

    /**
     * Execute the command
     *
     * @param InputInterface $input
     * @param OutputInterface $output
     *
     * @return null|int
     */
    protected function execute(InputInterface $input, OutputInterface $output): ?int
    {
        $result = $this->processFactory->getProcess('customer')->synchronizeData();
        $output->writeln('<info>Success Message.</info>');
        return 0;
    }
}
