<?php
namespace Pinpoint\Conesso\Model\Api\Management\Process;

use Magento\Framework\Api\SearchCriteriaBuilder;
use Pinpoint\Conesso\Api\Management\ProcessDataInterface;
use Pinpoint\Conesso\Api\Transfer\RequestProviderInterface;

abstract class AbstractProcess implements ProcessDataInterface
{
    /**
     * @var RequestProviderInterface
     */
    protected RequestProviderInterface $requestProvider;

    /**
     * @var SearchCriteriaBuilder
     */
    protected SearchCriteriaBuilder $searchCriteriaBuilder;

    /**
     * @param CreateContext $createContext
     */
    public function __construct(
        CreateContext $createContext
    ) {
        $this->requestProvider = $createContext->getRequestProvider();
        $this->searchCriteriaBuilder = $createContext->getSearchCriteriaBuilder();
    }
    abstract public function synchronizeData();

    abstract  public function migrateData();

}
