<?php
namespace Pinpoint\Conesso\Model;

use Magento\Framework\Model\AbstractModel;
use Pinpoint\Conesso\Api\Data\OrderSyncInterface;
use Pinpoint\Conesso\Model\ResourceModel\SyncOrders as SyncOrdersResourceModel;
class SyncOrders extends AbstractModel implements OrderSyncInterface
{
    /**
     * Cache tag
     */
    const CACHE_TAG = OrderSyncInterface::SCHEMA;

    protected function _construct()
    {
        $this->_init(SyncOrdersResourceModel::class);
    }

    public function getId() : ?int
    {
        return $this->getData(OrderSyncInterface::ID);
    }

    public function setId($id)
    {
        return $this->setData(OrderSyncInterface::ID, $id);
    }

    public function getOrderId() : ?int
    {
        return $this->getData(OrderSyncInterface::ORDER_ID);

    }

    public function setOrderId($orderId)
    {
        return $this->setData(OrderSyncInterface::ORDER_ID, $orderId);
    }

    public function getIncrementId() : ?int
    {
        return $this->getData(OrderSyncInterface::INCREMENT_ID);
    }

    public function setIncrementId($incrementId)
    {
        return $this->setData(OrderSyncInterface::ORDER_ID, $incrementId);
    }

    public function getEventType() : ?string
    {
        return $this->getData(OrderSyncInterface::EVENT_TYPE);
    }

    public function setEventType($eventType)
    {
        return $this->setData(OrderSyncInterface::EVENT_TYPE, $eventType);
    }

    public function getStoreId() : int
    {
        return $this->getData(OrderSyncInterface::STORE_ID);
    }

    public function setStoreId($storeId)
    {
        return $this->setData(OrderSyncInterface::STORE_ID, $storeId);
    }

    public function getCreatedAt()
    {
        return $this->getData(OrderSyncInterface::CREATED_AT);
    }

    public function setCreatedAt($createdAt)
    {
        return $this->setData(OrderSyncInterface::CREATED_AT, $createdAt);
    }

    public function getUpdatedAt()
    {
        return $this->getData(OrderSyncInterface::UPDATED_AT);
    }

    public function setUpdatedAt($updatedAt)
    {
        return $this->setData(OrderSyncInterface::UPDATED_AT, $updatedAt);
    }

    public function getIsSynced() : int
    {
        return $this->getData(OrderSyncInterface::IS_SYNCED);
    }

    public function setIsSynced($isSynced)
    {
        return $this->setData(OrderSyncInterface::IS_SYNCED, $isSynced);
    }

}
