<?php
namespace Pinpoint\Conesso\Observer\Cart;

use Exception;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Checkout\Model\Session as CheckoutSession;
use Pinpoint\Conesso\Api\Data\CartSyncInterface;
use Pinpoint\Conesso\Model\Api\Management\Log\Carts\LogCartInterface;

class Create implements ObserverInterface
{
    /**
     * @var CheckoutSession
     */
    private CheckoutSession $checkoutSession;

    /**
     * @var LogCartInterface
     */
    private LogCartInterface $logCart;

    /**
     * @param CheckoutSession $checkoutSession
     * @param LogCartInterface $logCart
     */
    public function __construct(
        CheckoutSession $checkoutSession,
        LogCartInterface $logCart
    )
    {
        $this->checkoutSession = $checkoutSession;
        $this->logCart = $logCart;
    }

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer): void
    {
        try {
            $cart = $this->checkoutSession->getQuote();
            $this->logCart->logCart($cart,CartSyncInterface::EVENT_TYPE_SAVE);
        } catch (Exception $e) {

        }
    }
}
