<?php
namespace Pinpoint\Conesso\Observer\Product;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Pinpoint\Conesso\Api\Data\ProductSyncInterface;
use Pinpoint\Conesso\Model\Api\Management\Log\Products\LogProductInterface;
use Psr\Log\LoggerInterface;

class ProductSaveAfter implements ObserverInterface
{

    /**
     * @var LogProductInterface
     */
    private LogProductInterface $logProduct;

    /**
     * @var LoggerInterface
     */
    private LoggerInterface $logger;

    /**
     * @param LogProductInterface $logProduct
     * @param LoggerInterface $logger
     */
    public function __construct(
        LogProductInterface $logProduct,
        LoggerInterface $logger
    ) {
        $this->logger = $logger;
        $this->logProduct = $logProduct;
    }

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        try {
            $product = $observer->getProduct();
            $this->logProduct->logProduct($product,ProductSyncInterface::EVENT_TYPE_SAVE);
        } catch (\Exception $e) {
            $this->logger->info(__($e->getMessage()));
        }
    }
}
