<?php
namespace Pinpoint\Conesso\Plugin\Order;

use Exception;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Api\OrderManagementInterface;
use Pinpoint\Conesso\Api\Data\OrderSyncInterface;
use Pinpoint\Conesso\Model\Api\Management\Log\Orders\LogOrderInterface;

class OrderPlace
{
    /**
     * @var LogOrderInterface
     */
    private LogOrderInterface $logOrder;

    /**
     * @param LogOrderInterface $logOrder
     */
    public function __construct(
        LogOrderInterface $logOrder
    ) {
        $this->logOrder = $logOrder;
    }

    /**
     * @param OrderManagementInterface $subject
     * @param OrderInterface $order
     * @return OrderInterface
     */
    public function afterPlace(
        OrderManagementInterface $subject,
        OrderInterface $order
    ): OrderInterface
    {
        try {
            $this->logOrder->logOrder($order, OrderSyncInterface::EVENT_TYPE_SAVE);
        } catch (Exception $e) {

        }
        return $order;
    }
}
